package package_modele;

import java.awt.Color;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.io.Serializable;
import java.nio.charset.StandardCharsets;
import java.nio.file.FileSystem;
import java.nio.file.FileSystems;
import java.nio.file.Files;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Vector;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import javax.swing.JOptionPane;
import java.beans.PersistenceDelegate;
import java.beans.XMLEncoder;
import java.io.FileOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

public class Tag implements Serializable
{

	
	private  Date DateCreation;
	private String nomTag ;
	public ArrayList<String> liensSymbo = new ArrayList<String>();
	static ArrayList<String> LiensSymboliquesDansTag = new ArrayList<String>();
	private File DossierTags;
	static DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
	 private String couleurTag ;
	 public static String TagXml="";
	 
	 
	 //*****************************constructeur par dfaut *****************************
	 public Tag()
	 {
		 this("");
	 }
	
	 //*******************************constructeur*************************************
	public Tag (String n)
	{
	  this.nomTag =n;	
	  this.DateCreation = new Date();
	  DossierTags = new File(Config.CHEMIN_TAGS + nomTag);
	  boolean b=DossierTags.mkdirs();
	  System.out.println("Creates the directory : " + b);
	  
	}
	 
	 
	
	
	
	
	//****************************** getteurs et setteurs ****************************

	
  //********************getdate()*************************************************
	
	public Date getdate()
	{
		
		return this.DateCreation ;
	}
	
	//************getNomTag()************************************************
    public String getnomTag ()
	{
		return this.nomTag;
	
	    }
    //**************getDateCreation()*****************************************
    public Date getDateCreation()
	{
		
		return this.DateCreation ;
	}
    //**********getDossierTags********************************
    
    public File  getDossierTags()
    {
    	return this.DossierTags;
    }
    //************getLiensSymboliquesDansTag()*****************************************
   
    public static ArrayList<String> getLiensSymboliquesDansTag(String NomTag)
	{
    	LiensSymboliquesDansTag = new ArrayList<String>();
    	System.out.println("getLiensSymbodanstag(" + NomTag + ")");
    	String cheminTag = toChemin(NomTag);
    	
    	System.out.println("le chemin absolue du tag est :"+cheminTag);
    	File fileTag = new File(cheminTag);
        String[] liens = fileTag.list() ;
   	   for (int j=0 ; j < liens.length ;j++)
   	   {
   		   LiensSymboliquesDansTag.add(liens[j]); 
   	   }
   	   return LiensSymboliquesDansTag;
   	  }
	
	
	
	//*******************getCouleur()****************************************************
	public String getCouleur ()
	{
		return this.couleurTag;
	}
	public Color getColor ()
	{
		String[] cols = this.couleurTag.split(",");
		return new Color(Integer.parseInt(cols[0]),Integer.parseInt(cols[1]),Integer.parseInt(cols[2]));
	}
	
	//******************setCouleur(Color c)***************************************************
	
	public void setCouleur(Color c){
		this.couleurTag =c.getRed() + "," + c.getGreen() + "," + c.getBlue();
	}
	//******************setCouleur(String c)***************************************************

	public void setCouleur(String c){
		this.couleurTag =c;
	}
	
//*********************************setNomTag()*************************************
	

	public void setNomTag ( String nom)
	{
		this.nomTag = nom;
	}
//**************************************************************************************************	
	
	
	  
	
	

	
	
	
	
	
	//*****************************rechercher_Tag****************************
	
	

public static File[] rechercher_Tag (String t)
{ 
	 File organiDocs = new File (Config.CHEMIN_TAGS);
	 File[]TousMesTags = organiDocs.listFiles();
	 File[] iner = null;
	 int i =0;
	 if (TousMesTags != null)
	 {

		 while (! t.equals(TousMesTags[i].getName()))
		 {
			 i++;
		 }
		 if (t.equals(TousMesTags[i].getName()))
		 {
				System.out.println(TousMesTags[i].isDirectory());

				 iner = TousMesTags[i].listFiles();
		 }
}
	return iner;
}

  //********************************copy()************************************************
 
 public static void copy(final InputStream inStream, final OutputStream outStream, final int bufferSize) throws IOException {
	 final byte[] buffer = new byte[bufferSize];
	 int nbRead;
	 while ((nbRead = inStream.read(buffer)) != -1) {
	 	outStream.write(buffer, 0, nbRead);
	 }
	}
	   
 //copier un dossier
	public static void copyDirectory(final File from, final File to) throws IOException {
	 if (! to.exists()) {
	 	to.mkdir();
	 }
	 final File[] inDir = from.listFiles();
	 for (int i = 0; i < inDir.length; i++) {
	 	final File file = inDir[i];
	 	copy(file, new File(to, file.getName()));
	 }
	}
	
	//**********************************copier un fichier***********************************
	
	
	public static void copyFile(final File from, final File to) throws IOException {
	 final InputStream inStream = new FileInputStream(from);
	 final OutputStream outStream = new FileOutputStream(to);
	 copy(inStream, outStream, (int) Math.min(from.length(), 4*1024));
	 inStream.close();
	 outStream.close();
	}
	
	
	
	//************* copier un fichier ou un dossier d'une source vers une destination ********************
	public static void copy(final File from, final File to) throws IOException {
	 if (from.isFile()) {
	 	copyFile(from, to);
	 } else if (from.isDirectory()){
	 	copyDirectory(from, to);
	 } else {
	 	throw new FileNotFoundException(from.toString() + " does not exist" );
	 }
	} 


	//******************************creerLienSymb()************************************************
public static void creerLienSymb (String NomDossierTag, File fichierAdeplacer) throws IOException
{
	boolean exist =  Tag.FichierPresentDansDossier(fichierAdeplacer.getName(), Config.CHEMIN_WORKSPACE);
	System.out.println("creerLienSymb " + exist + " : " + NomDossierTag + " : " + fichierAdeplacer.isFile());
	if (fichierAdeplacer.isFile())
	{
		// si je veux donner un autre tag  un fichier dj existant dans le workspace_organidoc
		if (exist == true)
		{
			FileSystem fs = FileSystems.getDefault();
			Files.createLink(fs.getPath(Config.CHEMIN_TAGS + NomDossierTag + "\\" + fichierAdeplacer.getName()),
			fs.getPath(Config.CHEMIN_WORKSPACE + fichierAdeplacer.getName()));
		}
		// si le fichier n existe pas dans le workspace
		if (exist == false)
		{
			File source = new File (fichierAdeplacer.getAbsolutePath());
			File dest = new File (Config.CHEMIN_WORKSPACE + fichierAdeplacer.getName());
			
			System.out.println("Copie du fichier dans le workspace... " + source.getAbsolutePath() + " a " + dest.getAbsolutePath());
			copy(source,dest);
			//source.delete(); //delete ne marche pas tt le temps
			
			String cheminWorkspace = Config.CHEMIN_WORKSPACE + fichierAdeplacer.getName();
			String cheminTags = Config.CHEMIN_TAGS + NomDossierTag + "\\" + fichierAdeplacer.getName();
			System.out.println("Creation du lien symbolique... : " + cheminTags + " ----- " + cheminWorkspace);
			FileSystem fs = FileSystems.getDefault();
			Files.createLink(fs.getPath(cheminTags), fs.getPath(cheminWorkspace));
		}	
	}
}	

	
	
	
	
	
//********************************************************************************	
	
 
 public static void proposer_Tag()
 {
	 
 }
 
 //***********************LesTagsDunFichier()************************************
 public static Vector<String> LesTagsDunFichier(String CheminFichier)
 {
	Vector<String> resultat = new Vector <String>();
	 File FileMonFichier = new File (CheminFichier);
	 String NomFichier = FileMonFichier.getName();
	 File DossierOrganiDocsTags = new File (Config.CHEMIN_TAGS);
     int j =0;
     
	 File[] FilesDossiersTags = DossierOrganiDocsTags.listFiles();
	 for(int i=0; i<FilesDossiersTags.length; i++)
		 
	 {   	 
		 System.out.println(FilesDossiersTags[i].getAbsolutePath()+"\n");
	     int k =0;
		 File[] f= FilesDossiersTags[i].listFiles();
		 int l = f.length;
		 while ((k < l)&& (! NomFichier.equals(f[k].getName())))
		 {
			k= k+1;
			
			}
		 
				
		 if (k >= f.length)
				 {
					 System.out.println("passage au tag suivant");
				 }else
				 {
					 
						 resultat.add(j,FilesDossiersTags[i].getName());

						 j++;
						
							 
				 }
		
		}
	 return resultat;

	 }

 //******************************TagsAvecTagRecherche*******************************************
 
 public static  Vector<Vector<String>>TagsAvecTagRecherche(String TagRecherche)
 {
	 Vector<Vector<String>> VFiles = new Vector<Vector<String>>();
	 File f = new File (TagRecherche);
	 File[] LiensDansTagsRecherche = f.listFiles();
	 for (int i=0; i< LiensDansTagsRecherche.length;i++ )
	 {   Vector <String> v =null;
	     System.out.println(LiensDansTagsRecherche[i].getAbsolutePath());
		  v = Tag.LesTagsDunFichier(LiensDansTagsRecherche[i].getAbsolutePath());
		 afficherVector(v);
		 VFiles.add(i,v );
	 }
	 
	return VFiles;
	 
 }
 //*************************************************************************************************
 public static void afficherVector (Vector<String> v)
 {
	 System.out.println("*************new vect**********************************\n");
	 for(int i =0; i<v.size();i++)
	 {  
		 System.out.println(v.elementAt(i));
	 }
 }
 
 public static void afficherVector2 (Vector<Vector<String>> v)
 {
	System.out.println( v.size());
	 for(int i =0; i<v.size();i++)
	 { 
		 System.out.println("affichage vecteur "+i+"\n");
		 afficherVector(v.elementAt(i));
	 }
 }
 //******************************toChemin(): prend le nom dun fichier et retourne son chemin absolue*************************************************
public static String toChemin (String nom)
{
	System.out.println("toChemin(" + nom + ")");
	File DossierOrganiDocsTags = new File(Config.CHEMIN_TAGS);
	File[] FilesDossiersTags = DossierOrganiDocsTags.listFiles();
	int k =0;
	String chemin = null;
	while (k < FilesDossiersTags.length && (!nom.equals(FilesDossiersTags[k].getName())))
	{
		k++;
	}	
	if (k >= FilesDossiersTags.length)
	{
		chemin = null;
	}
	else
	{
		chemin = FilesDossiersTags[k].getAbsolutePath();
	}
	return chemin;
}
 
 
//********************************* transforme le Tag en XML****************************************
	
	public static  String encodeTagToXML(Tag t)  {
	       
		TagXml = "";
	        	TagXml += "<Tag>\n";
	    		TagXml += "<NomTag>"+t.getnomTag()+"</NomTag>\n";
	    		TagXml +="<Couleur>"+t.getCouleur()+"</Couleur>\n";
	    		TagXml += "<DateCreation>"+t.getDateCreation()+"</DateCreation>\n";
	    		
	    		int i = 0;
	    		System.out.println("encodeTag : " + t.getnomTag());
	    		for(String s : t.liensSymbo)//getLiensSymboliquesDansTag(t.getnomTag())
	    		{
	    			System.out.println("liste de lien symbo : " + s);
	    			TagXml += "<LienSymbolique>" + s + "</LienSymbolique>\n";
	    			i++;
	    			if (i > 100)
	    			{
	    				System.out.println("SECURITE ANTIBOUCLEINFINIEgetLiensSymboliquesDansTag");
	    				break;
	    			}
	    		}
	    		TagXml += "</Tag>\n \n \n";
	    		return TagXml ;
	            
	        
	    }
   
	
 
 //******************************** toXml()******************************************************
 
 public static void toXml(ArrayList<Tag> TousMesTags) throws FileNotFoundException, IOException {
	 
	 try{
		 
    	   //FileOutputStream sortie = new FileOutputStream(Config.CHEMIN_ORGANIDOCS +  "tags.xml");
    	   //ObjectOutputStream p = new ObjectOutputStream(sortie);
    	   FileSystem fs = FileSystems.getDefault();
    	   BufferedWriter bw = new BufferedWriter(Files.newBufferedWriter(fs.getPath(Config.CHEMIN_ORGANIDOCS +  "tags.xml"), StandardCharsets.UTF_8));
    	   bw.write("<tags>");
    	   for (Tag tag : TousMesTags)
    	   {
    		   System.out.println("Export du tag : " + tag.getnomTag());
    		   String codexmltag = encodeTagToXML(tag);
    		   //p.writeObject(codexmltag);
    		   bw.write(codexmltag);
    	   }
    	   bw.write("</tags>");
    	   //p.flush();
    	   bw.flush();
    	   //sortie.close();
    	}catch(IOException ioe){
    	   System.out.println("erreur dans la srialisation : "+ ioe);
    	}
 }
 
 
//**********************************FichierPresentDansDossier()********************************************
   
 
 public static boolean FichierPresentDansDossier(String nomfichier, String chemindossier)
 {
	 boolean exist = false;
	 File FileDossier = new File(chemindossier);
	 String [] listeFichiersDansDossier  = FileDossier.list();
	 int parc = 0;
	 while (( parc <  listeFichiersDansDossier.length)&&(!nomfichier.equals(listeFichiersDansDossier[parc])))

	 {
		 parc++;
	 }
	 
	 
	 if (parc >= listeFichiersDansDossier.length)
	 {
         exist = false;

}else
	 {
		 exist=true;
	 }
	 return exist;
	 
	 
	 
	 
	
 }
}


	


