package package_vue;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;

import package_controleur.Controleur;

@SuppressWarnings("serial")
public class NewTag extends JFrame
{
	private Controleur controleur;
	private JColorChooser cc = new JColorChooser();
	private JLabel lblTag = new JLabel("Nom Tag : ");
	private JTextField tfTag = new JTextField("",6);
	private JButton btnOK = new JButton("OK");
	private GridBagConstraints gbc = new GridBagConstraints();
	public File fichier = null;
	public NewTag(Controleur c)
	{
		controleur = c;
		setSize(620,450);
		setTitle("Nouveau Tag");
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		if (fichier != null)
			setVisible(true);
		setLayout(new GridBagLayout());
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.gridwidth = GridBagConstraints.REMAINDER;
		add(cc, gbc);
		
		gbc.fill = GridBagConstraints.BOTH;
		
		gbc.gridwidth = 1;
		gbc.gridx = 0;
		gbc.gridy++;
		gbc.weighty = 1;
		lblTag.setFont(Panneau.POLICE24);
		add(lblTag, gbc);
		gbc.gridx++;
		tfTag.setFont(Panneau.POLICE24);
		add(tfTag, gbc);
		gbc.gridx = 0;
		gbc.gridy++;
		gbc.weighty = 0;
		gbc.gridwidth = GridBagConstraints.REMAINDER;
		gbc.fill = GridBagConstraints.NONE;
		btnOK.setFont(Panneau.POLICE24);
		add(btnOK, gbc);
		
		
		btnOK.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controleur.getModele().newTag(fichier, tfTag.getText(), cc.getColor());
				setVisible(false);
				tfTag.setText("");
			}
    	});
	}
}
